local uabStatus_MainDebuffs = uabUnitStatus:NewModule("Main Debuffs")

uabStatus_MainDebuffs.userdefined = {}
uabStatus_MainDebuffs.mixins = {}
uabStatus_MainDebuffs.mixins.aura = AceLibrary("SpecialEvents-Aura-2.0")

uabStatus_MainDebuffs.defaultDB = {
    disabled = nil,
    weaksoul = {
        disabled = nil,
        priority = 50,
        color = { r = 0.75, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
    },
    curse = {
        disabled = nil,
        priority = 50,
        color = { r = 0.75, g = 0, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    disease = {
        disabled = nil,
        priority = 50,
        color = { r = 1,    g = 0.75, b = 0, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    magic = {
        disabled = nil,
        priority = 50,
        color = { r = 0,    g = 0.25, b = 1, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    poison = {
        disabled = nil,
        priority = 50,
        color = { r = 0,    g = 1,    b = 0, a = 1, },
        classfilter = {
            druid = true,
            hunter = true,
            mage = true,
            paladin = true,
            priest = true,
            rogue = true,
            shaman = true,
            warlock = true,
            warrior = true,
        },
	},
    
    userdefined = {
    },
}

uabStatus_MainDebuffs.constants = {
    strings = {
        weaksoul = "Debuff: Weakened Soul",
        dcurse = "Debuff: Curse",
        ddisease = "Debuff: Disease",
        dmagic = "Debuff: Magic",
        dpoison = "Debuff: Poison",
        
        curse = "Curse",
        disease = "Disease",
        magic = "Magic",
        poison = "Poison",
        
    }
}

function uabStatus_MainDebuffs:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus("Debuffs", uabStatus_MainDebuffs.constants.strings.dcurse)
	self:RegisterUnitStatus("Debuffs", uabStatus_MainDebuffs.constants.strings.ddisease)
	self:RegisterUnitStatus("Debuffs", uabStatus_MainDebuffs.constants.strings.dmagic)
	self:RegisterUnitStatus("Debuffs", uabStatus_MainDebuffs.constants.strings.dpoison)
	self:RegisterUnitStatus("Debuffs", uabStatus_MainDebuffs.constants.strings.weaksoul)

    self:RegisterEvent("SpecialEvents_UnitDebuffGained")
    self:RegisterEvent("SpecialEvents_UnitDebuffLost")
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        self:RegisterUnitStatus("Debuffs", name)
    end
end

function uabStatus_MainDebuffs:SpecialEvents_UnitDebuffGained(unit, debuffName, applications, debuffType, texture, rank, index)
    local class = self:GetUnitClass(unit)
    local hasbuff
    
    if debuffName == uabStatus_MainDebuffs.constants.strings.weaksoul then
        if not class or self.db.profile.weaksoul.classfilter[class] then
            hasbuff = uabStatus_MainDebuffs.constants.strings.weaksoul
        end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.dcurse then
        if not class or self.db.profile.curse.classfilter[class] then
            hasbuff = uabStatus_MainDebuffs.constants.strings.curse
        end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.ddisease then
        if not class or self.db.profile.disease.classfilter[class] then
       	    hasbuff = uabStatus_MainDebuffs.constants.strings.disease
    	end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.dmagic then
        if not class or self.db.profile.magic.classfilter[class] then
            hasbuff = uabStatus_MainDebuffs.constants.strings.magic
    	end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.dpoison then
        if not class or self.db.profile.poison.classfilter[class] then
    	    hasbuff = uabStatus_MainDebuffs.constants.strings.poison
    	end
    end

    if not hasbuff then
        -- dynamically added buffs
        for dynname, settings in pairs(self.db.profile.userdefined) do
            if debuffName == settings.name then
                if not class or settings.classfilter[class] then
                    hasbuff = dynname
                end
                break
            end
        end
    end
    
    if hasbuff then
        self:UnitStatusGained(hasbuff, unit)
    end
end

function uabStatus_MainDebuffs:SpecialEvents_UnitDebuffLost(unit, debuffName, applications, debuffType, texture, rank)
    local class = self:GetUnitClass(unit)
    local hasbuff
    
    if debuffName == uabStatus_MainDebuffs.constants.strings.weaksoul then
        if not class or self.db.profile.weaksoul.classfilter[class] then
            hasbuff = uabStatus_MainDebuffs.constants.strings.weaksoul
        end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.dcurse then
        if not class or self.db.profile.curse.classfilter[class] then
            hasbuff = uabStatus_MainDebuffs.constants.strings.curse
        end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.ddisease then
        if not class or self.db.profile.disease.classfilter[class] then
       	    hasbuff = uabStatus_MainDebuffs.constants.strings.disease
    	end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.dmagic then
        if not class or self.db.profile.magic.classfilter[class] then
            hasbuff = uabStatus_MainDebuffs.constants.strings.magic
    	end
    elseif debuffType == uabStatus_MainDebuffs.constants.strings.dpoison then
        if not class or self.db.profile.poison.classfilter[class] then
    	    hasbuff = uabStatus_MainDebuffs.constants.strings.poison
    	end
    end

    if not hasbuff then
        -- dynamically added buffs
        for dynname, settings in pairs(self.db.profile.userdefined) do
            if debuffName == settings.name then
                if not class or settings.classfilter[class] then
                    hasbuff = dynname
                end
                break
            end
        end
    end
    
    if hasbuff then
        self:UnitStatusLost(hasbuff, unit)
    end
end

function uabStatus_MainDebuffs:OnEnable()
end

function uabStatus_MainDebuffs:OnDisable()
end

function uabStatus_MainDebuffs:IsStatusGained(name, unit, action)
    local class = self:GetUnitClass(unit)
    local has, debufftype
    local searchtype, searchname
    local enabled = 0
    local duration = 0
    local timeleft = 0
	
    if name == uabStatus_MainDebuffs.constants.strings.weaksoul then
        if not class or self.db.profile.weaksoul.classfilter[class] then
            searchname = uabStatus_MainDebuffs.constants.strings.weaksoul
        end
    elseif name == uabStatus_MainDebuffs.constants.strings.dcurse then
        if not class or self.db.profile.curse.classfilter[class] then
            searchtype = uabStatus_MainDebuffs.constants.strings.curse
        end
    elseif name == uabStatus_MainDebuffs.constants.strings.ddisease then
        if not class or self.db.profile.disease.classfilter[class] then
       	    searchtype = uabStatus_MainDebuffs.constants.strings.disease
    	end
    elseif name == uabStatus_MainDebuffs.constants.strings.dmagic then
        if not class or self.db.profile.magic.classfilter[class] then
            searchtype = uabStatus_MainDebuffs.constants.strings.magic
    	end
    elseif name == uabStatus_MainDebuffs.constants.strings.dpoison then
        if not class or self.db.profile.poison.classfilter[class] then
    	    searchtype = uabStatus_MainDebuffs.constants.strings.poison
    	end
    end

    if not searchtype and not searchname then
        -- dynamically added buffs
        for dynname, settings in pairs(self.db.profile.userdefined) do
            if name == dynname then
                if not class or settings.classfilter[class] then
                    searchname = settings.name
                end
                break
            end
        end
    end
    
    if searchtype or searchname then
        if searchtype then
            has = self.mixins.aura:UnitHasDebuffType(unit, searchtype)
        else
            has = self.mixins.aura:UnitHasDebuff(unit, searchname)
        end
        
        if has then
            local name, i
            
            i = 1
            while (UnitDebuff(unit, i) ~= nil) do
                name, _, _, _, debufftype, duration, timeleft = UnitDebuff(unit, i)
                if (searchtype and debufftype == searchtype) or (searchname and name == searchname) then
                    enabled = duration and timeleft and 1
                    break
                end
                i = i + 1
            end
        end
    end
    
    local start = 0
    
    if enabled and enabled > 0 and duration and duration > 0 and timeleft and timeleft > 0 then
        start = (GetTime() + timeleft) - duration
    end
    
    return has, enabled, start, duration
end

function uabStatus_MainDebuffs:OptionsForUnitStatus(name)
	if name == uabStatus_MainDebuffs.constants.strings.weaksoul then
		return self.db.profile.weaksoul
	elseif name == uabStatus_MainDebuffs.constants.strings.dcurse then
		return self.db.profile.curse
	elseif name == uabStatus_MainDebuffs.constants.strings.ddisease then
		return self.db.profile.disease
	elseif name == uabStatus_MainDebuffs.constants.strings.dmagic then
		return self.db.profile.magic
	elseif name == uabStatus_MainDebuffs.constants.strings.dpoison then
		return self.db.profile.poison
	end

    -- dynamically added buffs
    for dynname, settings in pairs(self.db.profile.userdefined) do
        if name == dynname then
            return settings
        end
    end
end

local lastorder

function uabStatus_MainDebuffs:RemoveUserDefined(buffname)
    local args = self.core.core.options.args.unitstatus.args[self.name]

    args.args[buffname] = nil
    args.args.remove.args[buffname] = nil
    self.db.profile.userdefined[buffname] = nil
    self:UnregisterUnitStatus("Debuffs", buffname)

    lastorder = 50
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        if not settings.name then
            settings.name = name
        end

        args.args[name].order = lastorder + 10
        lastorder = args.args[name].order
    end
    
    self:SetUserDefinedDebuffList()
end

function uabStatus_MainDebuffs:SetUserDefinedDebuffList()
    for pos, _ in pairs(self.userdefined) do
        self.userdefined[pos] = nil
    end

    local pos = 1
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        self.userdefined[pos] = name
        pos = pos + 1
    end
end

function uabStatus_MainDebuffs:CreateUnitStatusOptions()
    local args = {}

    args = {
        type = 'group',
        name = "Debuff",
        desc = "Configure the options for debuff unit status values",
        args = {
            enabled = {
                type = 'toggle',
                name = "Enabled",
                desc = "When checked, enable the use of the debuff unit status values",
                order = 1,
                get = function()
                    return not self.db.profile.disabled
                end,
                set = function(v)
                    self.db.profile.disabled = not v
                    self.core.core.main:FrameGroupsChanged()
                end,
            },

            addnew = {
                name = "Add New",
                type = 'text',
                desc = "Create a new debuff",
                usage = "<name>",
                order = 30,
                get = function() return end,
                set = function(newname)
                    self.db.profile.userdefined["Debuff: "..newname] = {
                        name = newname,
                        disabled = nil,
                        priority = 50,
                        color = { r = 0, g = 0, b = 1, a = 1, },
                        classfilter = {
                            druid = true,
                            hunter = true,
                            mage = true,
                            paladin = true,
                            priest = true,
                            rogue = true,
                            shaman = true,
                            warlock = true,
                            warrior = true,
                        },
                    }

                    self:RegisterUnitStatus("Debuffs", newname)

                    local args = self.core.core.options.args.unitstatus.args[self.name]
                                    
                    args.args["Debuff: "..newname] = self:CreateUnitStatusOption(self.db.profile.userdefined["Debuff: "..newname], "Debuff: "..newname, "Debuff: "..newname, true)
                    args.args["Debuff: "..newname].order = lastorder + 10
                    lastorder = args.args["Debuff: "..newname].order

                    args.args.remove.args["Debuff: "..newname] = {
                        type = 'execute',
                        name = "Debuff: "..newname,
                        desc = "Remove the ".."Debuff: "..newname.." debuff",
                        func = function()
                            self:RemoveUserDefined("Debuff: "..newname)
                        end,
                    }
    
                    self:SetUserDefinedDebuffList()
                end,
                validate = function(newname)
                    for name, settings in pairs(self.db.profile.userdefined) do
                        if name == "Debuff: "..newname then
                            return false
                        end
                    end
                    
                    return true
                end,
                order = 2,
            },

            remove = {
                type = 'group',
                name = "Remove",
                desc = "Remove a debuff",
                order = 3,
                args = {
                },
            },

            spacing3 = {
                name = " ",
                type = 'header',
                order = 5,
            },

        },
    }

    args.args["weaksoul"] = self:CreateUnitStatusOption(self.db.profile.weaksoul, uabStatus_MainDebuffs.constants.strings.weaksoul, uabStatus_MainDebuffs.constants.strings.weaksoul, true)
    args.args["weaksoul"].order = 5

    args.args["curse"] = self:CreateUnitStatusOption(self.db.profile.curse, uabStatus_MainDebuffs.constants.strings.dcurse, uabStatus_MainDebuffs.constants.strings.dcurse, true)
    args.args["curse"].order = 10

    args.args["disease"] = self:CreateUnitStatusOption(self.db.profile.disease, uabStatus_MainDebuffs.constants.strings.ddisease, uabStatus_MainDebuffs.constants.strings.ddisease, true)
    args.args["disease"].order = 20

    args.args["magic"] = self:CreateUnitStatusOption(self.db.profile.magic, uabStatus_MainDebuffs.constants.strings.dmagic, uabStatus_MainDebuffs.constants.strings.dmagic, true)
    args.args["magic"].order = 30

    args.args["poison"] = self:CreateUnitStatusOption(self.db.profile.poison, uabStatus_MainDebuffs.constants.strings.dpoison, uabStatus_MainDebuffs.constants.strings.dpoison, true)
    args.args["poison"].order = 40

    lastorder = 50
    
    -- dynamically added buffs
    for name, settings in pairs(self.db.profile.userdefined) do
        if not settings.name then
            settings.name = name
        end
        
        args.args[name] = self:CreateUnitStatusOption(settings, name, name, true)
        args.args[name].order = lastorder + 10
        lastorder = args.args[name].order
    end

    
    for name, settings in pairs(self.db.profile.userdefined) do
        args.args.remove.args[name] = {
            type = 'execute',
            name = name,
            desc = "Remove the "..settings.name.." debuff",
            order = 100,
            func = function()
                self:RemoveUserDefined(name)
            end,
        }
    end

    self:SetUserDefinedDebuffList()
    
    return args
end
